Unit Main;
{ ========================================================================== }
{ =   Lynx Tecnologia Eletrnica Ltda.                                     = }
{ =   Projeto:   Drivers / Windows 95                   Data: 14/nov/1998  = }
{ =   Programa:  Teste do driver VAD32D para Windows 95.                   = }
{ =   Mdulo:    Main                                                      = }
{ =   Autor:     Lauro                                                     = }
{ =   Descrio: Window principal do programa.                             = }
{ =   Verso:    1.0                                                       = }
{ ========================================================================== }

{-------------------------  Descrio da Interface  -------------------------}
Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, Buttons, Menus, ExtCtrls,
     TestAD, TestIRQ, ComCtrls;

{ ===================================================== }
{ =               Declarao de tipos                 = }
{ ===================================================== }

Type
  TMainForm = class(TForm)
    panBack     : TPanel;
    StatusBar   : TStatusBar;
    MainMenu    : TMainMenu;
    panControl  : TPanel;
    btOpen      : TBitBtn;
    btClose     : TBitBtn;
    btInit      : TBitBtn;
    btVersion   : TBitBtn;
    panTiControl: TPanel;
    panTest     : TPanel;
    panTiTest   : TPanel;
    btTestAD    : TBitBtn;
    btTestIRQ   : TBitBtn;
    Arquivo1    : TMenuItem;
    Sair1       : TMenuItem;
    lblEB_CAD: TLabel;
    cbEB_CAD    : TComboBox;
    lblIRQ      : TLabel;
    cbIRQ       : TComboBox;
    btTestDIO: TBitBtn;
    Procedure FormCreate (Sender: TObject);
    Procedure FormClose (Sender: TObject; var Action: TCloseAction);
    Procedure btCloseClick (Sender: TObject);
    Procedure btInitClick (Sender: TObject);
    Procedure btOpenClick (Sender: TObject);
    Procedure btTestADClick (Sender: TObject);
    Procedure btTestIRQClick (Sender: TObject);
    Procedure btVersionClick (Sender: TObject);
    Procedure Sair1Click (Sender: TObject);
    procedure btTestDIOClick(Sender: TObject);
  private
    { Private declarations }
    fOpen   : boolean;          { Indica se o VxD foi carregado }
    fInitCAD: boolean;          { Indica se o ADS2000 foi iniciado }
    Procedure FinalizaDriver;
    Procedure UpdateCommands;
  public
    { Public declarations }
  end;


{ ===================================================== }
{ =                Variveis globais                  = }
{ ===================================================== }

  Var MainForm: TMainForm;


{-------------------------  Descrio da Implementao ----------------------}
Implementation
  Uses VAD32api, TestDIO;

{$R *.DFM}

{ ===================================================== }
{ =           Declarao de variveis locais          = }
{ ===================================================== }

  Const
    cTabEB_CAD: array [0..3] of word = ($300, $308, $310, $318);

  Const
    cTabIRQ: array [0..2] of word = (5, 3, 4);

  Var
    ebCAD: word;
    IRQ  : word;


{ ========================================================================== }
{ =                   Implementao do objeto TMainForm                    = }
{ ========================================================================== }

{---------------------------------- TMainForm: Trata criao do formulrio --}
Procedure TMainForm.FormCreate (Sender: TObject);
  Var i   : smallint;
      sAux: string;
begin
  fOpen    := false;
  fInitCAD := false;
  cbEB_CAD.Clear;
  for  i := 0 to 3  do
  begin
    sAux := Format ('$%.3x', [cTabEB_CAD [i]]);
    cbEB_CAD.Items.Add (sAux);
  end;
  cbIRQ.Clear;
  for  i := 0 to 2  do
  begin
    sAux := Format ('IRQ%d', [cTabIRQ [i]]);
    cbIRQ.Items.Add (sAux);
  end;
  cbEB_CAD.ItemIndex := 0;
  cbIRQ.ItemIndex    := 0;
  UpdateCommands;
end;

{------------------------------- TMainForm: Trata fechamento do formulrio --}
Procedure TMainForm.FormClose (Sender: TObject; var Action: TCloseAction);
begin
  FinalizaDriver;
end;

{----------------------- TMainForm: Trata comando para fechar o driver VxD --}
Procedure TMainForm.btCloseClick (Sender: TObject);
begin
  FinalizaDriver;
  StatusBar.Panels.Items [1].Text := '';
  UpdateCommands;
end;

{----------------------- TMainForm: Trata comando para iniciar a placa A/D --}
Procedure TMainForm.btInitClick (Sender: TObject);
  Var Dummy: smallint;
      LPTn : byte;
      ebCAD: word;
begin
  ebCAD    := cTabEB_CAD [cbEB_CAD.ItemIndex];
  IRQ      := cTabIRq [cbIRQ.ItemIndex];
  fInitCAD := VAD32D_InitCard (ebCAD, IRQ);   { Inicia a placa A/D }
  if  fInitCAD  then
    StatusBar.Panels.Items [1].Text := 'Placa A/D iniciada'
  else
    StatusBar.Panels.Items [1].Text := 'Placa A/D no reconhecida!';
  UpdateCommands;
end;

{--------------------- TMainForm: Trata comando para carregar o driver VxD --}
Procedure TMainForm.btOpenClick (Sender: TObject);
begin
  fOpen := VAD32D_W32_Open;
  UpdateCommands;
end;

{------------------------ TMainForm: Trata comando de teste do E/S digital --}
Procedure TMainForm.btTestDIOClick (Sender: TObject);
begin
  dlgTestDIO.ShowModal;
end;

{------------------------ TMainForm: Trata comando de teste do A/D por WFF --}
Procedure TMainForm.btTestADClick (Sender: TObject);
begin
  dlgTestAD.tmrUpdate.Enabled := true;
  dlgTestAD.ShowModal;
end;

{---------- TMainForm: Trata comando de teste de aquisio por interrupo --}
Procedure TMainForm.btTestIRQClick (Sender: TObject);
begin
  dlgTestIRQ.ShowModal;
end;

{-------------- TMainForm: Trata comando para obter a verso do driver VxD --}
Procedure TMainForm.btVersionClick (Sender: TObject);
  Var Version: word;
begin
  Version := VAD32D_GetVersion;
  StatusBar.Panels.Items [0].Text := 'VAD32D ' + IntToStr (Hi (Version)) +
                                     '.' + IntToStr (Lo (Version));
end;

{---------------------------------------- TMainForm: Finaliza o driver VxD --}
Procedure TMainForm.FinalizaDriver;
begin
  if  fOpen
  then begin
    VAD32D_W32_Close;
    fOpen    := false;
    fInitCAD := false;
  end;
end;

{----------------------------------------- TMainForm: Finaliza a aplicao --}
Procedure TMainForm.Sair1Click (Sender: TObject);
begin
  Close;
end;

{------------------------------ TMainForm: Atualiza habilitao dos botes --}
Procedure TMainForm.UpdateCommands;
begin
  btOpen.Enabled    := not fOpen;
  btClose.Enabled   := fOpen;
  btTestDIO.Enabled := fOpen and fInitCAD;
  btTestAD.Enabled  := fOpen and fInitCAD;
  btTestIRQ.Enabled := fOpen and fInitCAD;
  btVersion.Enabled := fOpen;
  btInit.Enabled    := fOpen;
  cbEB_CAD.Enabled  := not fInitCAD;
  cbIRQ.Enabled     := not fInitCAD;
end;

end.
