Unit TestDIO;
{ ========================================================================== }
{ =   Lynx Tecnologia Eletronica Ltda.                                     = }
{ =   Projeto:   Drivers / Windows 95                   Data: 14/nov/1998  = }
{ =   Programa:  Teste do driver VAD32D para Windows 95.                   = }
{ =   Modulo:    TestDIO                                                   = }
{ =   Autor:     Lauro                                                     = }
{ =   Descricao: Teste da E/S Digital.                                     = }
{ =   Versao:    1.0                                                       = }
{ ========================================================================== }

{-------------------------  Descrio da Interface  -------------------------}
Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, ExtCtrls, Buttons, Spin;


{ ===================================================== }
{ =               Declarao de tipos                 = }
{ ===================================================== }

Type
  TdlgTestDIO = class(TForm)
    btClose        : TBitBtn;
    gbDigitalIput  : TGroupBox;   {-- Group box de Entrada Digital --}
    btReadDI       : TBitBtn;
    lblValDI       : TLabel;
    panReadDI      : TPanel;
    gbDigitalOutput: TGroupBox;   {-- Group box de Saida Digital --}
    btReadDO       : TBitBtn;
    btWriteDO      : TBitBtn;
    edWriteDO      : TEdit;
    lblValDO       : TLabel;
    gbLoopTest     : TGroupBox;   {-- Group box do Loop Test --}
    btLoopStart    : TBitBtn;
    btLoopStop     : TBitBtn;
    lblLoopDI      : TLabel;
    lblLoopDO      : TLabel;
    panLoopDI      : TPanel;
    panLoopDO      : TPanel;
    tmrLoop        : TTimer;
    Procedure FormCreate (Sender: TObject);
    Procedure btLoopStartClick (Sender: TObject);
    Procedure btLoopStopClick (Sender: TObject);
    Procedure btReadDIClick (Sender: TObject);
    Procedure tmrLoopTimer (Sender: TObject);
    procedure btWriteDOClick(Sender: TObject);
    procedure btReadDOClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    vDO   : word;    { Valor da saida digital no Loop Test }
    Estado: word;
  public
    { Public declarations }
  end;

{ ===================================================== }
{ =                Variveis globais                  = }
{ ===================================================== }

  Var dlgTestDIO: TdlgTestDIO;


{-------------------------  Descricao da Implementao ----------------------}
Implementation
  Uses VAD32api;

{$R *.DFM}

{ ========================================================================== }
{ =                  Implementao do objeto TdlgTestDIO                   = }
{ ========================================================================== }

{------------------------------------------ TdlgTestDIO: Cria o dialog box --}
Procedure TdlgTestDIO.FormCreate (Sender: TObject);
begin
  btLoopStop.Enabled := false;
  tmrLoop.Enabled    := false;
  edWriteDO.Text     := '0';
end;

{----------------------- TdlgTestDIO: Trata fechamento da caixa de dilogo --}
Procedure TdlgTestDIO.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  btLoopStop.Enabled := false;
  tmrLoop.Enabled    := false;
  edWriteDO.Text     := '0';
end;

{------------------------------------------ TdlgTestDIO: Trata boto Start --}
Procedure TdlgTestDIO.btLoopStartClick (Sender: TObject);
begin
  btReadDI.Enabled    := false;
  btReadDO.Enabled    := false;
  btWriteDO.Enabled   := false;
  btLoopStart.Enabled := false;
  btLoopStop.Enabled  := true;
  tmrLoop.Enabled     := true;
  tmrLoop.Interval    := 500;
  vDO    := 1;
  Estado := 0;
end;

{------------------------------------------- TdlgTestDIO: Trata boto Stop --}
Procedure TdlgTestDIO.btLoopStopClick (Sender: TObject);
begin
  btReadDI.Enabled    := true;
  btReadDO.Enabled    := true;
  btWriteDO.Enabled   := true;
  btLoopStart.Enabled := true;
  btLoopStop.Enabled  := false;
  tmrLoop.Enabled     := false;
end;

{---------------------------------------- TdlgTestDIO: Trata boto Read DI --}
Procedure TdlgTestDIO.btReadDIClick (Sender: TObject);
  Var Value: word;
begin
  Value := VAD32D_ReadDI;
  panReadDI.Caption := Format ('$%.4x', [Value]);
end;

{---------------------------------------- TdlgTestDIO: Trata boto Read DO --}
Procedure TdlgTestDIO.btReadDOClick(Sender: TObject);
  Var Value: word;
begin
  Value := VAD32D_ReadDO;
  edWriteDO.Text := Format ('$%.4x', [Value]);
end;

{--------------------------------------- TdlgTestDIO: Trata boto Write DO --}
Procedure TdlgTestDIO.btWriteDOClick (Sender: TObject);
  Var Valor: word;
begin
  try
    Valor := StrToInt (edWriteDO.Text);
    VAD32D_WriteDO (Valor);
  except
    on EConvertError do
      begin
        MessageDlg ('Valor invlido!', mtError, [mbOK], 0);
        ActiveControl := edWriteDO;
      end;
    on ERangeError do
      begin
        MessageDlg ('Valor fora da faixa!', mtError, [mbOK], 0);
        ActiveControl := edWriteDO;
      end;
  end;
end;

{---------------- TdlgTestDIO: Atualiza sada digital e l entrada digital --}
Procedure TdlgTestDIO.tmrLoopTimer (Sender: TObject);
  Var vDI: word;
begin
  panLoopDO.Caption := Format ('$%.4x', [vDO]);
  VAD32D_WriteDO (vDO);
  vDI := VAD32D_ReadDI;
  panLoopDI.Caption := Format ('$%.4x', [vDI]);
  case  Estado  of
    0: begin
         vDO := vDO shl 1;
         if  vDO = 0
         then begin
           Inc (Estado);
           vDO := $aaaa;
         end;
       end;
    1..10:
        begin
          vDO := not vDO;
          Inc (Estado);
        end;
    11: begin
          vDO := $fffe;
          Inc (Estado);
        end;
    12: begin
          vDO := not (not (vDO) shl 1);
          if  vDO = $ffff
          then begin
            Inc (Estado);
            vDO := 0;
            tmrLoop.Interval := 10;
          end;
        end;
    13: begin
          if  vDO <> $ffff  then
            Inc (vDO)
          else begin
            tmrLoop.Interval := 500;
            Estado := 0;
            vDO    := 1;
          end;
        end;
    else ;
  end;
end;

end.
