Attribute VB_Name = "Module1"
' ============================================================================
' =   Lynx Tecnologia Eletrnica Ltda.                                       =
' =   Projeto:   Drivers / Windows 95                     Data: 14/nov/1998  =
' =   Programa:  Teste do driver VAD32D para Windows 95.                     =
' =   Mdulo:    VAD32api                                                    =
' =   Autor:     Lauro                                                       =
' =   Descrio: Acesso s primitivas do driver VAD32D.VXD                   =
' =   Verso:    1.0                                                         =
' ============================================================================

' =====================================================
' =              Declarao de constantes             =
' =====================================================

  '----------------- Constantes referentes a configurao padro das placas --
  Public Const sbaCAD = &H300   ' Endereo base padro da CAD12/32
  Public Const sirCAD = 5       ' Interrupo padro da CAD12/32

  '----------------------------------------- ieXXXX: Interrupt error status --
  Public Const ieNoError = 0            ' Nenhum erro
  Public Const ieIntOverrun = 1         ' Overrun de interrupo
  Public Const ieAD_Error = 2           ' Error no conversor A/D
  Public Const ieBufOverrun = 3         ' Overflow no buffer de aquisio
  Public Const ieVPICD_Error = 4        ' VPICD cant virtualize IRQ
  Public Const ieEndAcquisition = 5     ' Fim da aquisio
  Public Const ieDriver = 100           ' Erro de acesso ao driver
  Public Const ieAcqStop = 101          ' Aquisio no est ativa
  Public Const ieBufSize = 102          ' Dimenso errada do buffer

  '-------------------------- Cdigos de ganho das entrada A/D da CAD12/32 --
  Public Const cBi5v0 = &HF0            ' -5.0 a 5.0 V
  Public Const cUni5v0 = &H70           '  0.0 a 5.0 V
  Public Const cBi2v5 = &HE0            ' -2.5 a 2.5 V
  Public Const cUni2v5 = &H60           '  0.0 a 2.5 V
  Public Const cBi1v0 = &HD0            ' -1.0 a 1.0 V
  Public Const cUni1v0 = &H50           '  0.0 a 1.0 V
  Public Const cBi0v5 = &HB0            ' -0.5 a 0.5 V
  Public Const cUni0v5 = &H30           '  0.0 a 0.5 V


' ============================================================================
' =                         Declarao de Tipos                              =
' ============================================================================

  Type TpBufArray                ' Buffer de transferncia de dados
    Dados(0 To 8191) As Integer
  End Type


' ============================================================================
' =           Primitivas do driver VAD32D.VXD acessados pela DLL             =
' ============================================================================

'------------------------------------------ Carrega o driver VxD VAD32D.VXD --
Declare Function VAD32D_W32_Open Lib "VAD32D.DLL" () As Boolean

'-------------------------------------------- Fecha o driver VxD VAD32D.VXD --
Declare Sub VAD32D_W32_Close Lib "VAD32D.DLL" ()

'-------------------- Devolve a verso do VAD32D: MSB: verso; LSB: reviso --
Declare Function VAD32D_GetVersion Lib "VAD32D.DLL" () As Integer

'---------------------------------------------- Inicia a placa A/D CAD12/32 --
Declare Function VAD32D_InitCard Lib "VAD32D.DLL" _
     (ByVal AbaCAD1232 As Integer, ByVal AIntNo As Byte) As Boolean

'---------------------------------- Programa o ganho de entrada da CAD12/32 --
Declare Sub VAD32D_SetGain Lib "VAD32D.DLL" (ByVal GainCode As Byte)

'-------------------------------------------- L canal de entrada analgica --
Declare Function VAD32D_ReadAI Lib "VAD32D.DLL" _
        (ByVal Channel As Byte, Value As Integer) As Boolean

'----------------- Leitura dos ports P0 e P1 de entrada digital da CAD12/32 --
Declare Function VAD32D_ReadDI Lib "VAD32D.DLL" () As Integer

'-------------- Retorna ltimo valor escritos nos ports P0 e P1 da CAD12/32 --
Declare Function VAD32D_ReadDO Lib "VAD32D.DLL" () As Integer

'------------------- Escreve nos ports P0 e P1 de sada digital da CAD12/32 --
Declare Sub VAD32D_WriteDO Lib "VAD32D.DLL" (ByVal Value As Integer)

'--------------------------------------------- Programa o Timer da CAD12/32 --
Declare Sub VAD32D_ProgTimer Lib "VAD32D.DLL" _
        (ByVal Channel As Byte, ByVal Mode As Byte, Count As Integer)

'-------------------------- Escreve no port P0 demsada digital da CAD12/32 --
Declare Function VAD32D_ReadTimer Lib "VAD32D.DLL" _
        (ByVal Channel As Byte) As Integer

'------------------------------------------------ Limpa a memria de canais --
Declare Sub VAD32D_ClearCM Lib "VAD32D.DLL" ()

'--------------------------------------- Programa memria de canais virtual --
Declare Sub VAD32D_WriteCM Lib "VAD32D.DLL" _
        (ByVal Channel As Byte, ByVal GainCode As Byte)

'----------------------------------------- Inicia aquisio por interrupo --
Declare Function VAD32D_StartAcquisition Lib "VAD32D.DLL" _
        (ByVal AFreqAq As Single, ByVal AnSamples As Long) As Boolean

'---------------------------------------- Encerra aquisio por interrupo --
Declare Sub VAD32D_StopAcquisition Lib "VAD32D.DLL" ()

'-------------------------------------- Prepara a aquisio por interrupo --
Declare Function VAD32D_GetSamples Lib "VAD32D.DLL" _
        (ErrorCode As Byte, iSample As Long, nSampRead As Long, _
         ByVal BufSize As Long, UserBuffer As TpBufArray) As Boolean


Public fMainForm As frmMain


Sub Main()
    Set fMainForm = New frmMain
    fMainForm.Show
End Sub



